diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java
index 483bf3a65..e8a6e1f00 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java
@@ -5,6 +5,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicSlab;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockModelSlab<T extends BlockLogicSlab> extends BlockModelStandard<T> {
     protected BlockModelStandard<T> parentModel;
@@ -18,13 +19,13 @@ public class BlockModelSlab<T extends BlockLogicSlab> extends BlockModelStandard
         withCustomItemBounds(0, 0, 0, 1, 0.5d, 1);
     }
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
         return parentModel.getBlockTextureFromSideAndMetadata(side, block.getLogic().modelBlockMetadata);
     }
 
     @Override
-    public IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side)
+    public @Nullable IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side)
     {
         return parentModel.getBlockTextureFromSideAndMetadata(side, block.getLogic().modelBlockMetadata);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabMarble.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabMarble.java
index cd9b156d6..b756ab8ae 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabMarble.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabMarble.java
@@ -7,6 +7,7 @@ import net.minecraft.core.block.BlockLogicSlab;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockModelSlabMarble<T extends BlockLogicSlab> extends BlockModelSlab<T> {
     protected IconCoordinate slabSide = TextureRegistry.getTexture("minecraft:block/carved_marble");
@@ -15,12 +16,12 @@ public class BlockModelSlabMarble<T extends BlockLogicSlab> extends BlockModelSl
     }
 
     @Override
-    public IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side)
+    public @Nullable IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side)
     {
         return getBlockTextureFromSideAndMetadata(side, blockAccess.getBlockMetadata(x, y, z));
     }
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
         if(data != 1 && (side.getAxis() != Axis.Y))
         {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabPainted.java
index 8d3bd72f1..7fb6e7ce3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabPainted.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabPainted.java
@@ -5,6 +5,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicSlab;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockModelSlabPainted<T extends BlockLogicSlab> extends BlockModelSlab<T> {
     public BlockModelSlabPainted(Block<T> block) {
@@ -12,13 +13,13 @@ public class BlockModelSlabPainted<T extends BlockLogicSlab> extends BlockModelS
     }
 
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int meta) {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int meta) {
         meta = meta >> 4;
         return BlockModelPlanksPainted.texCoords[meta & 0x0F];
     }
 
     @Override
-    public IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side)
+    public @Nullable IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side)
     {
         return getBlockTextureFromSideAndMetadata(side, blockAccess.getBlockMetadata(x, y, z));
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java
index 44397d205..7cf1a1471 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java
@@ -8,6 +8,9 @@ import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicSpikes;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.DisplayPos;
 
 public class BlockModelSpikes<T extends BlockLogic> extends BlockModelStandard<T> {
     public BlockModelSpikes(Block<T> block) {
@@ -15,22 +18,22 @@ public class BlockModelSpikes<T extends BlockLogic> extends BlockModelStandard<T
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
-        int metaData = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        int metaData = worldSource.getBlockMetadata(x, y, z);
         IconCoordinate texture = getBlockTextureFromSideAndMetadata(Side.EAST, metaData);
         if(renderBlocks.overrideBlockTexture != null)
         {
             texture = renderBlocks.overrideBlockTexture;
         }
 
-        renderStandardBlock(tessellator, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 0.1875F, 1.0F), x, y, z);
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 0.1875F, 1.0F), x, y, z);
 
         if(BlockLogicSpikes.isSpikesUp(metaData)) {
             float brightness = 1.0f;
             if(LightmapHelper.isLightmapEnabled()) {
-            	tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
+            	tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, x, y, z));
             }else {
-            	brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+            	brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
             }
             tessellator.setColorOpaque_F(brightness, brightness, brightness);
             double uMin = texture.getIconUMin();
@@ -106,8 +109,4 @@ public class BlockModelSpikes<T extends BlockLogic> extends BlockModelStandard<T
     public boolean shouldItemRender3d() {
         return false;
     }
-    @Override
-    public float getItemRenderScale() {
-        return 0.5f;
-    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
index 563d440dd..9e79395c1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
@@ -8,10 +8,15 @@ import net.minecraft.core.block.BlockLogicStairs;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
+import org.useless.dragonfly.DisplayPos;
 
 public class BlockModelStairs<T extends BlockLogicStairs> extends BlockModelStandard<T> {
+    protected static final DisplayPos STAIRS_GUI = new DisplayPos(0, 0, 0, 30, 135, 0, 0.625f, 0.625f, 0.625f);
+    protected static final DisplayPos STAIRS_HEAD = new DisplayPos(0, 0, 0, 0, -90, 0, 1f, 1f, 1f);
+    protected static final DisplayPos STAIRS_THIRD_PERSON_LEFT_HAND = new DisplayPos(0, 2.5f/16f, 0, 75, -135, 0, 0.375f, 0.375f, 0.375f);
     protected BlockModelStandard<T> parentModel;
     public BlockModelStairs(Block<T> block) {
         super(block);
@@ -20,11 +25,15 @@ public class BlockModelStairs<T extends BlockLogicStairs> extends BlockModelStan
         overbrightTextures.copy(parentModel.overbrightTextures);
         retroBlockTextures.copy(parentModel.retroBlockTextures);
         retroOverbrightTextures.copy(parentModel.retroOverbrightTextures);
+
+        setDisplayPos(DisplayPos.GUI, STAIRS_GUI);
+        setDisplayPos(DisplayPos.HEAD, STAIRS_HEAD);
+        setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, STAIRS_THIRD_PERSON_LEFT_HAND);
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
-        int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        int meta = worldSource.getBlockMetadata(x, y, z);
         int hRotation = meta & 0b0011;
         int vRotation = meta & 0b1000;
 
@@ -35,37 +44,37 @@ public class BlockModelStairs<T extends BlockLogicStairs> extends BlockModelStan
         if(hRotation == 0)
         {
             bounds.set(0.0F, 0.0F + stepYOffset, 0.0F, 0.5F, 0.5F + stepYOffset, 1.0F);
-            renderStandardBlock(tessellator, bounds, x, y, z);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
             bounds.set(0.5F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
-            renderStandardBlock(tessellator, bounds, x, y, z);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
         } else
         if(hRotation == 1)
         {
             bounds.set(0.0F, 0.0F, 0.0F, 0.5F, 1.0F, 1.0F);
-            renderStandardBlock(tessellator, bounds, x, y, z);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
             bounds.set(0.5F, 0.0F + stepYOffset, 0.0F, 1.0F, 0.5F + stepYOffset, 1.0F);
-            renderStandardBlock(tessellator, bounds, x, y, z);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
         } else
         if(hRotation == 2)
         {
             bounds.set(0.0F, 0.0F + stepYOffset, 0.0F, 1.0F, 0.5F + stepYOffset, 0.5F);
-            renderStandardBlock(tessellator, bounds, x, y, z);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
             bounds.set(0.0F, 0.0F, 0.5F, 1.0F, 1.0F, 1.0F);
-            renderStandardBlock(tessellator, bounds, x, y, z);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
         } else {
             bounds.set(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 0.5F);
-            renderStandardBlock(tessellator, bounds, x, y, z);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
             bounds.set(0.0F, 0.0F + stepYOffset, 0.5F, 1.0F, 0.5F + stepYOffset, 1.0F);
-            renderStandardBlock(tessellator, bounds, x, y, z);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
         }
         return true;
     }
 
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         if(renderBlocks.useInventoryTint)
         {
-            int j = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
+            int j = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata, 0);
             float f1 = (float)(j >> 16 & 0xff) / 255F;
             float f3 = (float)(j >> 8 & 0xff) / 255F;
             float f5 = (float)(j & 0xff) / 255F;
@@ -76,52 +85,52 @@ public class BlockModelStairs<T extends BlockLogicStairs> extends BlockModelStan
             AABB bounds;
             if(l == 0)
             {
-                bounds = AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 0.5F);
+                bounds = AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 0.5F, 1.0F);
             } else {
-                bounds = AABB.getTemporaryBB(0.0F, 0.0F, 0.5F, 1.0F, 0.5F, 1.0F);
+                bounds = AABB.getTemporaryBB(0.5F, 0.5F, 0.0F, 1.0F, 1.0F, 1.0F);
             }
             GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
             tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, -1F, 0.0F);
-            renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata));
+            renderBlocks.renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata));
             tessellator.draw();
 
             tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 1.0F, 0.0F);
-            renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.TOP, metadata));
+            renderBlocks.renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.TOP, metadata));
             tessellator.draw();
 
             tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 0.0F, -1F);
-            renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.NORTH, metadata));
+            renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.NORTH, metadata));
             tessellator.draw();
 
             tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 0.0F, 1.0F);
-            renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.SOUTH, metadata));
+            renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.SOUTH, metadata));
             tessellator.draw();
 
             tessellator.startDrawingQuads();
             tessellator.setNormal(-1F, 0.0F, 0.0F);
-            renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.WEST, metadata));
+            renderBlocks.renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.WEST, metadata));
             tessellator.draw();
 
             tessellator.startDrawingQuads();
             tessellator.setNormal(1.0F, 0.0F, 0.0F);
-            renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
+            renderBlocks.renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
             tessellator.draw();
 
             GL11.glTranslatef(0.5F, 0.5F, 0.5F);
         }
     }
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
         return parentModel.getBlockTextureFromSideAndMetadata(side, data);
     }
 
     @Override
-    public IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side)
+    public @Nullable IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side)
     {
         return parentModel.getBlockTexture(blockAccess, x, y, z, side);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairsPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairsPainted.java
index c60850ab1..3aa0e7be2 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairsPainted.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairsPainted.java
@@ -5,6 +5,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicStairs;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockModelStairsPainted<T extends BlockLogicStairs> extends BlockModelStairs<T> {
     public BlockModelStairsPainted(Block<T> block) {
@@ -12,13 +13,13 @@ public class BlockModelStairsPainted<T extends BlockLogicStairs> extends BlockMo
     }
 
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int meta) {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int meta) {
         meta = meta >> 4;
         return BlockModelPlanksPainted.texCoords[meta & 0x0F];
     }
 
     @Override
-    public IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side)
+    public @Nullable IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side)
     {
         return getBlockTextureFromSideAndMetadata(side, blockAccess.getBlockMetadata(x, y, z));
     }
